﻿RAnnouncer = LibStub("AceAddon-3.0"):NewAddon("RAnnouncer", "AceConsole-3.0", "AceEvent-3.0", "AceTimer-3.0");
local AceConfig = LibStub("AceConfig-3.0");
local AceCongigDialog = LibStub("AceConfigDialog-3.0");

local player = UnitName("player")
local idc
local db
local RAnn_version = "1.3"

-- global variables used in addon

local AArea = {
	S =L["Say"],
        P =L["Party"],
        RA = L["Raid"],
        RW = L["Raid Warning"]
}
local k,v
-- options settings
local options = {
	type = "group",
	name = "RAnnouncer",
	handler = RAnnouncer,
	guiInline = true,
	get = GetProfileOpt,
	set = SetProfileOpt,
	args = {
		rann = {
			type = "group",
			name = "RAnnouncer",
			childGroups = "tree",
			order = 1,
			args = {
                                -- Rogue options
				rogue = {
					type = "group",
					name = L["Rogue"],
					desc = L["Rogue skills and talents to display"],
					childGroups = "tree",
					order = 1,
					args = {
                                                A13877 = {
                                                        type = "group",
                                                        name = L["Blade Flurry"],
                                                        order = 10,
                                                        args = {
                                                                IsEnabled = { 
                                                                        type = "toggle",
                                                                        name = "Enable",
                                                                        desc = L["Enable announcing of this skill"],
				                			set = "SetValues",
					                		get = "GetValues",
                                                                        order = 10,
                                                                },
                                                                Announce = {
                                                                        type = "input",
                                                                        name = L["Announcment"],
                                                                        desc = L["Message to announce, %s - skill, %t - target, %i - time"],
                                                                        get = function(info, _) return db.skillsV[info[#info-1]].ann end,
                                                                        set = function(info, val) db.skillsV[info[#info-1]].ann = val end,
                                                                        order = 15,
                                                                },
                						AnnounceList = {
	                						type = "multiselect",
		                					name = L["Announce to"],
			                				desc = L["Where announces should be displayed"],
				                			set = "SetAValues",
					                		get = "GetAValues",
						                	values = AArea,
							                order = 20,
                						},
                                                        },
                                                },
                                                A13750 = {
                                                        type = "group",
                                                        name = L["Adrenaline Rush"],
                                                        order = 20,
                                                        args = {
                                                                IsEnabled = { 
                                                                        type = "toggle",
                                                                        name = L["Enable"],
                                                                        desc = L["Enable announcing of this skill"],
				                			set = "SetValues",
					                		get = "GetValues",
                                                                        order = 10,
                                                                },
                                                                Announce = {
                                                                        type = "input",
                                                                        name = L["Announcment"],
                                                                        desc = L["Message to announce, %s - skill, %t - target, %i - time"],
                                                                        get = function(info, _) return db.skillsV[info[#info-1]].ann end,
                                                                        set = function(info, val) db.skillsV[info[#info-1]].ann = val end,
                                                                        order = 15,
                                                                },
                						AnnounceList = {
	                						type = "multiselect",
		                					name = L["Announce"],
			                				desc = L["Where announces should be displayed"],
				                			set = "SetAValues",
					                		get = "GetAValues",
						                	values = AArea,
							                order = 20,
                						},
                                                        },
                                                },

                                                A2094 = {
                                                        type = "group",
                                                        name = L["Blind"],
                                                        order = 30,
                                                        args = {
                                                                IsEnabled = { 
                                                                        type = "toggle",
                                                                        name = L["Enable"],
                                                                        desc = L["Enable announcing of this skill"],
				                			set = "SetValues",
					                		get = "GetValues",
                                                                        order = 10,
                                                                },
                                                                Announce = {
                                                                        type = "input",
                                                                        name = L["Announcment"],
                                                                        desc =L["Message to announce, %s - skill, %t - target, %i - time"],
                                                                        get = function(info, _) return db.skillsV[info[#info-1]].ann end,
                                                                        set = function(info, val) db.skillsV[info[#info-1]].ann = val end,
                                                                        order = 15,
                                                                },
                						AnnounceList = {
	                						type = "multiselect",
		                					name = L["Announce"],
			                				desc = L["Where announces should be displayed"],
				                			set = "SetAValues",
					                		get = "GetAValues",
						                	values = AArea,
							                order = 20,
                						},
                                                        },
                                                },
                                                A26669 = {
                                                        type = "group",
                                                        name = L["Evasion"],
                                                        order = 40,
                                                        args = {
                                                                IsEnabled = { 
                                                                        type = "toggle",
                                                                        name = L["Enable"],
                                                                        desc = L["Enable announcing of this skill"],
				                			set = "SetValues",
					                		get = "GetValues",
                                                                        order = 10,
                                                                },
                                                                Announce = {
                                                                        type = "input",
                                                                        name = L["Announcment"],
                                                                        desc = L["Message to announce, %s - skill, %t - target, %i - time"],
                                                                        get = function(info, _) return db.skillsV[info[#info-1]].ann end,
                                                                        set = function(info, val) db.skillsV[info[#info-1]].ann = val end,
                                                                        order = 15,
                                                                },
                						AnnounceList = {
	                						type = "multiselect",
		                					name = L["Announce"],
			                				desc = L["Where announces should be displayed"],
				                			set = "SetAValues",
					                		get = "GetAValues",
						                	values = AArea,
							                order = 20,
                						},
                                                        },
                                                },
                                                A11297 = {
                                                        type = "group",
                                                        name = L["Sap"],
                                                        order = 50,
                                                        args = {
                                                                IsEnabled = { 
                                                                        type = "toggle",
                                                                        name = L["Enable"],
                                                                        desc = L["Enable announcing of this skill"],
				                			set = "SetValues",
					                		get = "GetValues",
                                                                        order = 10,
                                                                },
                                                                Announce = {
                                                                        type = "input",
                                                                        name = L["Announcment"],
                                                                        desc = L["Message to announce, %s - skill, %t - target, %i - time"],
                                                                        get = function(info, _) return db.skillsV[info[#info-1]].ann end,
                                                                        set = function(info, val) db.skillsV[info[#info-1]].ann = val end,
                                                                        order = 15,
                                                                },
                						AnnounceList = {
	                						type = "multiselect",
		                					name = L["Announce"],
			                				desc = L["Where announces should be displayed"],
				                			set = "SetAValues",
					                		get = "GetAValues",
						                	values = AArea,
							                order = 20,
                						},
                                                        },
                                                },
                                                A38768 = {
                                                        type = "group",
                                                        name = L["Kick"],
                                                        order = 60,
                                                        args = {
                                                                IsEnabled = { 
                                                                        type = "toggle",
                                                                        name = L["Enable"],
                                                                        desc = L["Enable announcing of this skill"],
				                			set = "SetValues",
					                		get = "GetValues",
                                                                        order = 10,
                                                                },
                                                                Announce = {
                                                                        type = "input",
                                                                        name = L["Announcment"],
                                                                        desc = L["Message to announce, %s - skill, %t - target, %i - time"],
                                                                        get = function(info, _) return db.skillsV[info[#info-1]].ann end,
                                                                        set = function(info, val) db.skillsV[info[#info-1]].ann = val end,
                                                                        order = 15,
                                                                },
                						AnnounceList = {
	                						type = "multiselect",
		                					name = L["Announce"],
			                				desc = L["Where announces should be displayed"],
				                			set = "SetAValues",
					                		get = "GetAValues",
						                	values = AArea,
							                order = 20,
                						},
                                                        },
                                                },
                                                A1725 = {
                                                        type = "group",
                                                        name = L["Distract"],
                                                        order = 70,
                                                        args = {
                                                                IsEnabled = { 
                                                                        type = "toggle",
                                                                        name = L["Enable"],
                                                                        desc = L["Enable announcing of this skill"],
				                			set = "SetValues",
					                		get = "GetValues",
                                                                        order = 10,
                                                                },
                                                                Announce = {
                                                                        type = "input",
                                                                        name = L["Announcment"],
                                                                        desc = L["Message to announce, %s - skill, %t - target, %i - time"],
                                                                        get = function(info, _) return db.skillsV[info[#info-1]].ann end,
                                                                        set = function(info, val) db.skillsV[info[#info-1]].ann = val end,
                                                                        order = 15,
                                                                },
                						AnnounceList = {
	                						type = "multiselect",
		                					name = L["Announce"],
			                				desc = L["Where announces should be displayed"],
				                			set = "SetAValues",
					                		get = "GetAValues",
						                	values = AArea,
							                order = 20,
                						},
                                                        },
                                                },
					},
				},
				druid = {
					type = "group",
					name = L["Druid"],
					desc = L["Druid skills and talents to display"],
					childGroups = "tree",
					order = 2,
					args = {
                                                A5209 = {
                                                        type = "group",
                                                        name = L["Challenging Roar"],
                                                        order = 10,
                                                        args = {
                                                                IsEnabled = { 
                                                                        type = "toggle",
                                                                        name = L["Enable"],
                                                                        desc = L["Enable announcing of this skill"],
				                			set = "SetValues",
					                		get = "GetValues",
                                                                        order = 10,
                                                                },
                                                                Announce = {
                                                                        type = "input",
                                                                        name = L["Announcment"],
                                                                        desc = L["Message to announce, %s - skill, %t - target, %i - time"],
                                                                        get = function(info, _) return db.skillsV[info[#info-1]].ann end,
                                                                        set = function(info, val) db.skillsV[info[#info-1]].ann = val end,
                                                                        order = 15,
                                                                },
                						AnnounceList = {
	                						type = "multiselect",
		                					name = L["Announce"],
			                				desc = L["Where announces should be displayed"],
				                			set = "SetAValues",
					                		get = "GetAValues",
						                	values = AArea,
							                order = 20,
                						},
                                                        },
                                                },
                                                A29166 = {
                                                        type = "group",
                                                        name = L["Innervate"],
                                                        order = 20,
                                                        args = {
                                                                IsEnabled = { 
                                                                        type = "toggle",
                                                                        name = L["Enable"],
                                                                        desc = L["Enable announcing of this skill"],
				                			set = "SetValues",
					                		get = "GetValues",
                                                                        order = 10,
                                                                },
                                                                Announce = {
                                                                        type = "input",
                                                                        name = L["Announcment"],
                                                                        desc = L["Message to announce, %s - skill, %t - target, %i - time"],
                                                                        get = function(info, _) return db.skillsV[info[#info-1]].ann end,
                                                                        set = function(info, val) db.skillsV[info[#info-1]].ann = val end,
                                                                        order = 15,
                                                                },
                						AnnounceList = {
	                						type = "multiselect",
		                					name = L["Announce"],
			                				desc = L["Where announces should be displayed"],
				                			set = "SetAValues",
					                		get = "GetAValues",
						                	values = AArea,
							                order = 20,
                						},
                                                        },
                                                },
                                                A26994 = {
                                                        type = "group",
                                                        name = L["Rebirth"],
                                                        order = 30,
                                                        args = {
                                                                IsEnabled = { 
                                                                        type = "toggle",
                                                                        name = L["Enable"],
                                                                        desc = L["Enable announcing of this skill"],
				                			set = "SetValues",
					                		get = "GetValues",
                                                                        order = 10,
                                                                },
                                                                Announce = {
                                                                        type = "input",
                                                                        name = L["Announcment"],
                                                                        desc = L["Message to announce, %s - skill, %t - target, %i - time"],
                                                                        get = function(info, _) return db.skillsV[info[#info-1]].ann end,
                                                                        set = function(info, val) db.skillsV[info[#info-1]].ann = val end,
                                                                        order = 15,
                                                                },
                						AnnounceList = {
	                						type = "multiselect",
		                					name = L["Announce"],
			                				desc = L["Where announces should be displayed"],
				                			set = "SetAValues",
					                		get = "GetAValues",
						                	values = AArea,
							                order = 20,
                						},
                                                        },
                                                },
                                                A26983 = {
                                                        type = "group",
                                                        name = L["Tranquility"],
                                                        order = 40,
                                                        args = {
                                                                IsEnabled = { 
                                                                        type = "toggle",
                                                                        name = L["Enable"],
                                                                        desc = L["Enable announcing of this skill"],
				                			set = "SetValues",
					                		get = "GetValues",
                                                                        order = 10,
                                                                },
                                                                Announce = {
                                                                        type = "input",
                                                                        name = L["Announcment"],
                                                                        desc = L["Message to announce, %s - skill, %t - target, %i - time"],
                                                                        get = function(info, _) return db.skillsV[info[#info-1]].ann end,
                                                                        set = function(info, val) db.skillsV[info[#info-1]].ann = val end,
                                                                        order = 15,
                                                                },
                						AnnounceList = {
	                						type = "multiselect",
		                					name = L["Announce"],
			                				desc = L["Where announces should be displayed"],
				                			set = "SetAValues",
					                		get = "GetAValues",
						                	values = AArea,
							                order = 20,
                						},
                                                        },
                                                },
					},
				},
                                hunter  = {
                                        type = "group",
                                        name = L["Hunter"],
                                        desc = L["Hunter skills and abilities to display"],
                                        childGroups = "tree",
                                        order = 3,
                                        args = {
                                                A34477  = {
                                                        type = "group",
                                                        name = L["Misdirection"],
                                                        order = 10,
                                                        args = {
                                                                IsEnabled = { 
                                                                        type = "toggle",
                                                                        name = L["Enable"],
                                                                        desc = L["Enable announcing of this skill"],
				                			set = "SetValues",
					                		get = "GetValues",
                                                                        order = 10,
                                                                },
                                                                Announce = {
                                                                        type = "input",
                                                                        name = L["Announcment"],
                                                                        desc = L["Message to announce, %s - skill, %t - target, %i - time"],
                                                                        get = function(info, _) return db.skillsV[info[#info-1]].ann end,
                                                                        set = function(info, val) db.skillsV[info[#info-1]].ann = val end,
                                                                        order = 15,
                                                                },
                						AnnounceList = {
	                						type = "multiselect",
		                					name = L["Announce"],
			                				desc = L["Where announces should be displayed"],
				                			set = "SetAValues",
					                		get = "GetAValues",
						                	values = AArea,
							                order = 20,
                						},
                                                        },
                                                },
                                        },
                                },
				priest = {
					type = "group",
					name = L["Priest"],
					desc = L["Priest skills and talents to display"],
					childGroups = "tree",
					order = 4,
					args = {
                                                A10955 = {
                                                        type = "group",
                                                        name = L["Shackle Undead"],
                                                        order = 10,
                                                        args = {
                                                                IsEnabled = { 
                                                                        type = "toggle",
                                                                        name = L["Enable"],
                                                                        desc = L["Enable announcing of this skill"],
				                			set = "SetValues",
					                		get = "GetValues",
                                                                        order = 10,
                                                                },
                                                                Announce = {
                                                                        type = "input",
                                                                        name = L["Announcment"],
                                                                        desc = L["Message to announce, %s - skill, %t - target, %i - time"],
                                                                        get = function(info, _) return db.skillsV[info[#info-1]].ann end,
                                                                        set = function(info, val) db.skillsV[info[#info-1]].ann = val end,
                                                                        order = 15,
                                                                },
                						AnnounceList = {
	                						type = "multiselect",
		                					name = L["Announce"],
			                				desc = L["Where announces should be displayed"],
				                			set = "SetAValues",
					                		get = "GetAValues",
						                	values = AArea,
							                order = 20,
                						},
                                                        },
                                                },
                                                A25435 = {
                                                        type = "group",
                                                        name = L["Resurrection"],
                                                        order = 20,
                                                        args = {
                                                                IsEnabled = { 
                                                                        type = "toggle",
                                                                        name = L["Enable"],
                                                                        desc = L["Enable announcing of this skill"],
				                			set = "SetValues",
					                		get = "GetValues",
                                                                        order = 10,
                                                                },
                                                                Announce = {
                                                                        type = "input",
                                                                        name = L["Announcment"],
                                                                        desc = L["Message to announce, %s - skill, %t - target, %i - time"],
                                                                        get = function(info, _) return db.skillsV[info[#info-1]].ann end,
                                                                        set = function(info, val) db.skillsV[info[#info-1]].ann = val end,
                                                                        order = 15,
                                                                },
                						AnnounceList = {
	                						type = "multiselect",
		                					name = L["Announce"],
			                				desc = L["Where announces should be displayed"],
				                			set = "SetAValues",
					                		get = "GetAValues",
						                	values = AArea,
							                order = 20,
                						},
                                                        },
                                                },
					},
				},
				paladin = {
					type = "group",
					name = L["Paladin"],
					desc = L["Paladin skills and talents to display"],
					childGroups = "tree",
					order = 5,
					args = {
                                                A27154 = {
                                                        type = "group",
                                                        name = L["Lay on Hands"],
                                                        order = 10,
                                                        args = {
                                                                IsEnabled = { 
                                                                        type = "toggle",
                                                                        name = L["Enable"],
                                                                        desc = L["Enable announcing of this skill"],
				                			set = "SetValues",
					                		get = "GetValues",
                                                                        order = 10,
                                                                },
                                                                Announce = {
                                                                        type = "input",
                                                                        name = L["Announcment"],
                                                                        desc = L["Message to announce, %s - skill, %t - target, %i - time"],
                                                                        get = function(info, _) return db.skillsV[info[#info-1]].ann end,
                                                                        set = function(info, val) db.skillsV[info[#info-1]].ann = val end,
                                                                        order = 15,
                                                                },
                						AnnounceList = {
	                						type = "multiselect",
		                					name = L["Announce"],
			                				desc = L["Where announces should be displayed"],
				                			set = "SetAValues",
					                		get = "GetAValues",
						                	values = AArea,
							                order = 20,
                						},
                                                        },
                                                },
                                                A19752 = {
                                                        type = "group",
                                                        name = L["Divine Intervention"],
                                                        order = 20,
                                                        args = {
                                                                IsEnabled = { 
                                                                        type = "toggle",
                                                                        name = L["Enable"],
                                                                        desc = L["Enable announcing of this skill"],
				                			set = "SetValues",
					                		get = "GetValues",
                                                                        order = 10,
                                                                },
                                                                Announce = {
                                                                        type = "input",
                                                                        name = L["Announcment"],
                                                                        desc = L["Message to announce, %s - skill, %t - target, %i - time"],
                                                                        get = function(info, _) return db.skillsV[info[#info-1]].ann end,
                                                                        set = function(info, val) db.skillsV[info[#info-1]].ann = val end,
                                                                        order = 15,
                                                                },
                						AnnounceList = {
	                						type = "multiselect",
		                					name = L["Announce"],
			                				desc = L["Where announces should be displayed"],
				                			set = "SetAValues",
					                		get = "GetAValues",
						                	values = AArea,
							                order = 20,
                						},
                                                        },
                                                },
						A10278 = {
							type = "group",
                                                        name = L["Blessing of Protection"],
                                                        order = 30,
                                                        args = {
                                                                IsEnabled = { 
                                                                        type = "toggle",
                                                                        name = L["Enable"],
                                                                        desc = L["Enable announcing of this skill"],
				                			set = "SetValues",
					                		get = "GetValues",
                                                                        order = 10,
                                                                },
                                                                Announce = {
                                                                        type = "input",
                                                                        name = L["Announcment"],
                                                                        desc = L["Message to announce, %s - skill, %t - target, %i - time"],
                                                                        get = function(info, _) return db.skillsV[info[#info-1]].ann end,
                                                                        set = function(info, val) db.skillsV[info[#info-1]].ann = val end,
                                                                        order = 15,
                                                                },
                						AnnounceList = {
	                						type = "multiselect",
		                					name = L["Announce"],
			                				desc = L["Where announces should be displayed"],
				                			set = "SetAValues",
					                		get = "GetAValues",
						                	values = AArea,
							                order = 20,
                						},
                                                        },
                                                A20773 = {
                                                        type = "group",
                                                        name = L["Redemption"],
                                                        order = 40,
                                                        args = {
                                                                IsEnabled = { 
                                                                        type = "toggle",
                                                                        name = L["Enable"],
                                                                        desc = L["Enable announcing of this skill"],
				                			set = "SetValues",
					                		get = "GetValues",
                                                                        order = 10,
                                                                },
                                                                Announce = {
                                                                        type = "input",
                                                                        name = L["Announcment"],
                                                                        desc = L["Message to announce, %s - skill, %t - target, %i - time"],
                                                                        get = function(info, _) return db.skillsV[info[#info-1]].ann end,
                                                                        set = function(info, val) db.skillsV[info[#info-1]].ann = val end,
                                                                        order = 15,
                                                                },
                						AnnounceList = {
	                						type = "multiselect",
		                					name = L["Announce"],
			                				desc = L["Where announces should be displayed"],
				                			set = "SetAValues",
					                		get = "GetAValues",
						                	values = AArea,
							                order = 20,
                						},
                                                        },
                                                },
					},
				},
				shaman = {
					type = "group",
					name = L["Shaman"],
					desc = L["Shaman skills and talents to display"],
					childGroups = "tree",
					order = 6,
					args = {
                                                A2825 = {
                                                        type = "group",
                                                        name = L["Bloodlust"],
                                                        order = 10,
                                                        args = {
                                                                IsEnabled = { 
                                                                        type = "toggle",
                                                                        name = L["Enable"],
                                                                        desc = L["Enable announcing of this skill"],
				                			set = "SetValues",
					                		get = "GetValues",
                                                                        order = 10,
                                                                },
                                                                Announce = {
                                                                        type = "input",
                                                                        name = L["Announcment"],
                                                                        desc = L["Message to announce, %s - skill, %t - target, %i - time"],
                                                                        get = function(info, _) return db.skillsV[info[#info-1]].ann end,
                                                                        set = function(info, val) db.skillsV[info[#info-1]].ann = val end,
                                                                        order = 15,
                                                                },
                						AnnounceList = {
	                						type = "multiselect",
		                					name = L["Announce"],
			                				desc = L["Where announces should be displayed"],
				                			set = "SetAValues",
					                		get = "GetAValues",
						                	values = AArea,
							                order = 20,
                						},
                                                        },
                                                },
                                                A32182 = {
                                                        type = "group",
                                                        name = L["Heroism"],
                                                        order = 20,
                                                        args = {
                                                                IsEnabled = { 
                                                                        type = "toggle",
                                                                        name = L["Enable"],
                                                                        desc = L["Enable announcing of this skill"],
				                			set = "SetValues",
					                		get = "GetValues",
                                                                        order = 10,
                                                                },
                                                                Announce = {
                                                                        type = "input",
                                                                        name = L["Announcment"],
                                                                        desc = L["Message to announce, %s - skill, %t - target, %i - time"],
                                                                        get = function(info, _) return db.skillsV[info[#info-1]].ann end,
                                                                        set = function(info, val) db.skillsV[info[#info-1]].ann = val end,
                                                                        order = 15,
                                                                },
                						AnnounceList = {
	                						type = "multiselect",
		                					name = L["Announce"],
			                				desc = L["Where announces should be displayed"],
				                			set = "SetAValues",
					                		get = "GetAValues",
						                	values = AArea,
							                order = 20,
                						},
                                                        },
                                                },
                                                A16190 = {
                                                        type = "group",
                                                        name = L["Mana Tide"],
                                                        order = 30,
                                                        args = {
                                                                IsEnabled = { 
                                                                        type = "toggle",
                                                                        name = L["Enable"],
                                                                        desc = L["Enable announcing of this skill"],
				                			set = "SetValues",
					                		get = "GetValues",
                                                                        order = 10,
                                                                },
                                                                Announce = {
                                                                        type = "input",
                                                                        name = L["Announcment"],
                                                                        desc = L["Message to announce, %s - skill, %t - target, %i - time"],
                                                                        get = function(info, _) return db.skillsV[info[#info-1]].ann end,
                                                                        set = function(info, val) db.skillsV[info[#info-1]].ann = val end,
                                                                        order = 15,
                                                                },
                						AnnounceList = {
	                						type = "multiselect",
		                					name = L["Announce"],
			                				desc = L["Where announces should be displayed"],
				                			set = "SetAValues",
					                		get = "GetAValues",
						                	values = AArea,
							                order = 20,
                						},
                                                        },
                                                },
                                                A20777 = {
                                                        type = "group",
                                                        name = L["Ancestral Spirit"],
                                                        order = 40,
                                                        args = {
                                                                IsEnabled = { 
                                                                        type = "toggle",
                                                                        name = L["Enable"],
                                                                        desc = L["Enable announcing of this skill"],
				                			set = "SetValues",
					                		get = "GetValues",
                                                                        order = 10,
                                                                },
                                                                Announce = {
                                                                        type = "input",
                                                                        name = L["Announcment"],
                                                                        desc = L["Message to announce, %s - skill, %t - target, %i - time"],
                                                                        get = function(info, _) return db.skillsV[info[#info-1]].ann end,
                                                                        set = function(info, val) db.skillsV[info[#info-1]].ann = val end,
                                                                        order = 15,
                                                                },
                						AnnounceList = {
	                						type = "multiselect",
		                					name = L["Announce"],
			                				desc = L["Where announces should be displayed"],
				                			set = "SetAValues",
					                		get = "GetAValues",
						                	values = AArea,
							                order = 20,
                						},
                                                        },
                                                },
					},
				},
				warlock = {
					type = "group",
					name = L["Warlock"],
					desc = L["Warlock skills and talents to display"],
					childGroups = "tree",
					order = 7,
					args = {
                                                A18647 = {
                                                        type = "group",
                                                        name = L["Banish"],
                                                        order = 10,
                                                        args = {
                                                                IsEnabled = { 
                                                                        type = "toggle",
                                                                        name = L["Enable"],
                                                                        desc = L["Enable announcing of this skill"],
				                			set = "SetValues",
					                		get = "GetValues",
                                                                        order = 10,
                                                                },
                                                                Announce = {
                                                                        type = "input",
                                                                        name = L["Announcment"],
                                                                        desc = L["Message to announce, %s - skill, %t - target, %i - time"],
                                                                        get = function(info, _) return db.skillsV[info[#info-1]].ann end,
                                                                        set = function(info, val) db.skillsV[info[#info-1]].ann = val end,
                                                                        order = 15,
                                                                },
                						AnnounceList = {
	                						type = "multiselect",
		                					name = L["Announce"],
			                				desc = L["Where announces should be displayed"],
				                			set = "SetAValues",
					                		get = "GetAValues",
						                	values = AArea,
							                order = 20,
                						},
                                                        },
                                                },
                                                A698 = {
                                                        type = "group",
                                                        name = L["Ritual of Summoning"],
                                                        order = 20,
                                                        args = {
                                                                IsEnabled = { 
                                                                        type = "toggle",
                                                                        name = L["Enable"],
                                                                        desc = L["Enable announcing of this skill"],
				                			set = "SetValues",
					                		get = "GetValues",
                                                                        order = 10,
                                                                },
                                                                Announce = {
                                                                        type = "input",
                                                                        name = L["Announcment"],
                                                                        desc = L["Message to announce, %s - skill, %t - target, %i - time"],
                                                                        get = function(info, _) return db.skillsV[info[#info-1]].ann end,
                                                                        set = function(info, val) db.skillsV[info[#info-1]].ann = val end,
                                                                        order = 15,
                                                                },
                						AnnounceList = {
	                						type = "multiselect",
		                					name = L["Announce"],
			                				desc = L["Where announces should be displayed"],
				                			set = "SetAValues",
					                		get = "GetAValues",
						                	values = AArea,
							                order = 20,
                						},
                                                        },
                                                },
                                                A29893 = {
                                                        type = "group",
                                                        name = L["Ritual of Souls"],
                                                        order = 30,
                                                        args = {
                                                                IsEnabled = { 
                                                                        type = "toggle",
                                                                        name = L["Enable"],
                                                                        desc = L["Enable announcing of this skill"],
				                			set = "SetValues",
					                		get = "GetValues",
                                                                        order = 10,
                                                                },
                                                                Announce = {
                                                                        type = "input",
                                                                        name = L["Announcment"],
                                                                        desc = L["Message to announce, %s - skill, %t - target, %i - time"],
                                                                        get = function(info, _) return db.skillsV[info[#info-1]].ann end,
                                                                        set = function(info, val) db.skillsV[info[#info-1]].ann = val end,
                                                                        order = 15,
                                                                },
                						AnnounceList = {
	                						type = "multiselect",
		                					name = L["Announce"],
			                				desc = L["Where announces should be displayed"],
				                			set = "SetAValues",
					                		get = "GetAValues",
						                	values = AArea,
							                order = 20,
                						},
                                                        },
                                                },
                                                A27239 = {
                                                        type = "group",
                                                        name = L["Soulstone Resurrection"],
                                                        order = 40,
                                                        args = {
                                                                IsEnabled = { 
                                                                        type = "toggle",
                                                                        name = L["Enable"],
                                                                        desc = L["Enable announcing of this skill"],
				                			set = "SetValues",
					                		get = "GetValues",
                                                                        order = 10,
                                                                },
                                                                Announce = {
                                                                        type = "input",
                                                                        name = L["Announcment"],
                                                                        desc = L["Message to announce, %s - skill, %t - target, %i - time"],
                                                                        get = function(info, _) return db.skillsV[info[#info-1]].ann end,
                                                                        set = function(info, val) db.skillsV[info[#info-1]].ann = val end,
                                                                        order = 15,
                                                                },
                						AnnounceList = {
	                						type = "multiselect",
		                					name = L["Announce"],
			                				desc = L["Where announces should be displayed"],
				                			set = "SetAValues",
					                		get = "GetAValues",
						                	values = AArea,
							                order = 20,
                						},
                                                        },
                                                },
					},
				},
				warrior = {
					type = "group",
					name = L["Warrior"],
					desc = L["Warrior skills and abilities to display"],
					childGroups = "tree",
					order = 8,
					args = {
                                                A12975 = {
                                                        type = "group",
                                                        name = L["Last Stand"],
                                                        order = 10,
                                                        args = {
                                                                IsEnabled = { 
                                                                        type = "toggle",
                                                                        name = L["Enable"],
                                                                        desc = L["Enable announcing of this skill"],
				                			set = "SetValues",
					                		get = "GetValues",
                                                                        order = 10,
                                                                },
                                                                Announce = {
                                                                        type = "input",
                                                                        name = L["Announcment"],
                                                                        desc = L["Message to announce, %s - skill, %t - target, %i - time"],
                                                                        get = function(info, _) return db.skillsV[info[#info-1]].ann end,
                                                                        set = function(info, val) db.skillsV[info[#info-1]].ann = val end,
                                                                        order = 15,
                                                                },
                						AnnounceList = {
	                						type = "multiselect",
		                					name = L["Announce"],
			                				desc = L["Where announces should be displayed"],
				                			set = "SetAValues",
					                		get = "GetAValues",
						                	values = AArea,
							                order = 20,
                						},
                                                        },
                                                },
                                                A871 = {
                                                        type = "group",
                                                        name = L["Shield Wall"],
                                                        order = 20,
                                                        args = {
                                                                IsEnabled = { 
                                                                        type = "toggle",
                                                                        name = L["Enable"],
                                                                        desc = L["Enable announcing of this skill"],
				                			set = "SetValues",
					                		get = "GetValues",
                                                                        order = 10,
                                                                },
                                                                Announce = {
                                                                        type = "input",
                                                                        name = L["Announcment"],
                                                                        desc = L["Message to announce, %s - skill, %t - target, %i - time"],
                                                                        get = function(info, _) return db.skillsV[info[#info-1]].ann end,
                                                                        set = function(info, val) db.skillsV[info[#info-1]].ann = val end,
                                                                        order = 15,
                                                                },
                						AnnounceList = {
	                						type = "multiselect",
		                					name = L["Announce"],
			                				desc = L["Where announces should be displayed"],
				                			set = "SetAValues",
					                		get = "GetAValues",
						                	values = AArea,
							                order = 20,
                						},
                                                        },
                                                },
                                                A1719 = {
                                                        type = "group",
                                                        name = L["Recklessness"],
                                                        order = 30,
                                                        args = {
                                                                IsEnabled = { 
                                                                        type = "toggle",
                                                                        name = L["Enable"],
                                                                        desc = L["Enable announcing of this skill"],
				                			set = "SetValues",
					                		get = "GetValues",
                                                                        order = 10,
                                                                },
                                                                Announce = {
                                                                        type = "input",
                                                                        name = L["Announcment"],
                                                                        desc = L["Message to announce, %s - skill, %t - target, %i - time"],
                                                                        get = function(info, _) return db.skillsV[info[#info-1]].ann end,
                                                                        set = function(info, val) db.skillsV[info[#info-1]].ann = val end,
                                                                        order = 15,
                                                                },
                						AnnounceList = {
	                						type = "multiselect",
		                					name = L["Announce"],
			                				desc = L["Where announces should be displayed"],
				                			set = "SetAValues",
					                		get = "GetAValues",
						                	values = AArea,
							                order = 20,
                						},
                                                        },
                                                },

					},
				},
				items = {
					type = "group",
					name = L["Items"],
					desc = L["Item buffs to display"],
					childGroups = "tree",
					order = 9,
					args = {
                                                A35476 = {
                                                        type = "group",
                                                        name = L["Drums of Battle"],
                                                        order = 10,
                                                        args = {
                                                                IsEnabled = { 
                                                                        type = "toggle",
                                                                        name = L["Enable"],
                                                                        desc = L["Enable announcing of this skill"],
				                			set = "SetValues",
					                		get = "GetValues",
                                                                        order = 10,
                                                                },
                                                                Announce = {
                                                                        type = "input",
                                                                        name = L["Announcment"],
                                                                        desc = L["Message to announce, %s - skill, %t - target, %i - time"],
                                                                        get = function(info, _) return db.skillsV[info[#info-1]].ann end,
                                                                        set = function(info, val) db.skillsV[info[#info-1]].ann = val end,
                                                                        order = 15,
                                                                },
                						AnnounceList = {
	                						type = "multiselect",
		                					name = L["Announce"],
			                				desc = L["Where announces should be displayed"],
				                			set = "SetAValues",
					                		get = "GetAValues",
						                	values = AArea,
							                order = 20,
                						},
                                                        },
                                                },
                                                A35475 = {
                                                        type = "group",
                                                        name = L["Drums of War"],
                                                        order = 20,
                                                        args = {
                                                                IsEnabled = { 
                                                                        type = "toggle",
                                                                        name = L["Enable"],
                                                                        desc = L["Enable announcing of this skill"],
				                			set = "SetValues",
					                		get = "GetValues",
                                                                        order = 10,
                                                                },
                                                                Announce = {
                                                                        type = "input",
                                                                        name = L["Announcment"],
                                                                        desc = L["Message to announce, %s - skill, %t - target, %i - time"],
                                                                        get = function(info, _) return db.skillsV[info[#info-1]].ann end,
                                                                        set = function(info, val) db.skillsV[info[#info-1]].ann = val end,
                                                                        order = 15,
                                                                },
                						AnnounceList = {
	                						type = "multiselect",
		                					name = L["Announce"],
			                				desc = L["Where announces should be displayed"],
				                			set = "SetAValues",
					                		get = "GetAValues",
						                	values = AArea,
							                order = 20,
                						},
                                                        },
                                                },
                                                A35478 = {
                                                        type = "group",
                                                        name = L["Drums of Restoration"],
                                                        order = 30,
                                                        args = {
                                                                IsEnabled = { 
                                                                        type = "toggle",
                                                                        name = L["Enable"],
                                                                        desc = L["Enable announcing of this skill"],
				                			set = "SetValues",
					                		get = "GetValues",
                                                                        order = 10,
                                                                },
                                                                Announce = {
                                                                        type = "input",
                                                                        name = L["Announcment"],
                                                                        desc = L["Message to announce, %s - skill, %t - target, %i - time"],
                                                                        get = function(info, _) return db.skillsV[info[#info-1]].ann end,
                                                                        set = function(info, val) db.skillsV[info[#info-1]].ann = val end,
                                                                        order = 15,
                                                                },
                						AnnounceList = {
	                						type = "multiselect",
		                					name = L["Announce"],
			                				desc = L["Where announces should be displayed"],
				                			set = "SetAValues",
					                		get = "GetAValues",
						                	values = AArea,
							                order = 20,
                						},
                                                        },
                                                },

					},
				},
			},
		},
	},
}

-- saved variables settings

local defaults = {
	profile = {
                skillsV = {
                        --   skillID = { enabled, { say, party, raid, raidwarning }, duration(optional), targeted(optional), name },

                        -- Rogue
                        A13877   = {	enable	= true,
					chat	= { 
						S	= false,
						P	= true,
						RA	= false,
						RW	= false },
					dura	= 0,
					target	= false,
					name	= L["Blade Flurry"],
                                        ann     = L["{moon}{moon} %s used! {moon}{moon}"] }, 

                        A13750   = {	enable	= false,
					chat	= {
						S	= false,
						P	= true,
						RA	= false,
						RW	= false },
					dura	= 0, 
					target	= false, 
					name	= L["Adrenaline Rush"],
                                        ann     = L["{skull}{skull} %s used! {skull}{skull}"] },  

                        A2094    = {	enable	= true,
					chat	 = { 
						S	= false,	
						P	= true, 
						RA	= false,
						RW	= false }, 
					dura	= 0, 
					target	= true, 
					name	= L["Blind"],
                                        ann     = L["{skull}{skull} %s used on %t! {skull}{skull}"] }, 

                        A26669   = {	enable	= true,
					chat	= { 
						S	= false,
						P	= true, 
						RA	= false, 
						RW	= false }, 
					dura	= 0, 
					target	= false, 
					name	= L["Evasion"],
                                        ann     = L["{skull}{skull} %s used! {skull}{skull}"] }, 

                        A11297   = {	enable	= true,
					chat	= { 
						S	= false,	
						P	= true, 
						RA	= false, 
						RW	= false }, 
					dura	= 30, 
					target	= false, 
					name	= L["Sap"],
                                        ann     = L["{skull}{skull} %s used on %t (%i secs)! {skull}{skull}"] }, 
                        A38768   = {	enable	= true,
					chat	= { 
						S	= false,
						P	= true,
						RA	= false,
						RW	= false },
					dura	= 0, 
					target	= true, 
					name	= L["Kick"],
                                        ann     = L["{skull}{skull} %s'd %t! {skull}{skull}"] }, 
                        A1725    = {	enable	= true,
					chat	= { 
						S	= false,
						P	= true, 
						RA	= false,
						RW	= false }, 
					dura	= 0,
					target	= false,
					name	= L["Distract"],
                                        ann     = L["{skull}{skull} %s used! {skull}{skull}"] }, 
                        -- Druid
			A5209    = {	enable	= true,
					chat	= { 
						S	= false,
						P	= true, 
						RA	= false,
						RW	= false }, 
					dura	= 0,
					target	= false,
					name	= L["Challenging Roar"],
                                        ann     = L["{skull}{skull} %s used! {skull}{skull}"] }, 
                        A29166    = {	enable	= true,
					chat	= { 
						S	= false,
						P	= false, 
						RA	= true,
						RW	= false }, 
					dura	= 0,
					target	= true,
					name	= L["Innervate"],
                                        ann     = L["{skull}{skull} %s on %t used! {skull}{skull}"] }, 
                        A26994    = {	enable	= true,
					chat	= { 
						S	= false,
						P	= false, 
						RA	= true,
						RW	= false }, 
					dura	= 0,
					target	= true,
					name	= L["Rebirth"],
                                        ann     = L["{skull}{skull} %s on %t used! {skull}{skull}"] }, 
                        A26983    = {	enable	= true,
					chat	= { 
						S	= true,
						P	= false, 
						RA	= false,
						RW	= false }, 
					dura	= 0,
					target	= false,
					name	= L["Tranquility"],
                                        ann     = L["{skull}{skull} %s used! {skull}{skull}" ]},  
                        -- Priest
                        A10955    = {	enable	= true,
					chat	= { 
						S	= false,
						P	= false, 
						RA	= true,
						RW	= false }, 
					dura	= 0,
					target	= true,
					name	= L["Shackle Undead"],
                                        ann     = L["{skull}{skull} %s on %t {skull}{skull}"] }, 
                        A25435    = {	enable	= true,
					chat	= { 
						S	= true,
						P	= false, 
						RA	= false,
						RW	= false }, 
					dura	= 0,
					target	= true,
					name	= L["Resurrection"],
                                        ann     = L["Ressing %t !"] }, 
                        -- Paladin
                        A27154    = {	enable	= true,
					chat	= { 
						S	= false,
						P	= false, 
						RA	= true,
						RW	= false }, 
					dura	= 0,
					target	= true,
					name	= L["Lay on Hands"],
                                        ann     = L["{skull}{skull} %s on %t! {skull}{skull}"] }, 
                        A19752    = {	enable	= true,
					chat	= { 
						S	= false,
						P	= false, 
						RA	= true,
						RW	= false }, 
					dura	= 0,
					target	= true,
					name	= L["Divine Intervention"],
                                        ann     = L["{skull}{skull} %s on %t! {skull}{skull}"] }, 
                        A20773    = {	enable	= true,
					chat	= { 
						S	= true,
						P	= false, 
						RA	= false,
						RW	= false }, 
					dura	= 0,
					target	= true,
					name	= L["Redemption"],
                                        ann     = L["{skull}{skull} Ressing %t {skull}{skull}"] }, 
			A10278    = {	enable	= true,
					chat	= { 
						S	= true,
						P	= false, 
						RA	= false,
						RW	= false }, 
					dura	= 0,
					target	= true,
					name	= L["Blessing of Protection"],
                                        ann     = L["{skull}{skull} %s on %t {skull}{skull}"] }, 
                	-- Shaman
                        A2825    = {	enable	= true,
					chat	= { 
						S	= false,
						P	= true, 
						RA	= false,
						RW	= false }, 
					dura	= 40,
					target	= false,
					name	= L["Bloodlust"],
                                        ann     = L["{skull}{skull} %s used! {skull}{skull}"],
                                        fann    = L["{skull}{skull} %s is about to fade in 5 secs {skull}{skull}"],
                                        eann    = L["{skull}{skull} %s fading now! {skull}{skull}"] }, 
                        A32182    = {	enable	= false,
					chat	= { 
						S	= false,
						P	= true, 
						RA	= false,
						RW	= false }, 
					dura	= 40,
					target	= false,
					name	= L["Heroism"],
                                        ann     = L["{skull}{skull} %s used! {skull}{skull}" ,] 
                                        fann    = L["{skull}{skull} %s is about to fade in 5 secs {skull}{skull}"],
                                        eann    = L["{skull}{skull} %s fading now! {skull}{skull}"] }, 
                        A16190    = {	enable	= true,
					chat	= { 
						S	= false,
						P	= true, 
						RA	= false,
						RW	= false }, 
					dura	= 0,
					target	= false,
					name	= L["Mana Tide"],
                                        ann     = L["{skull}{skull} %s used! {skull}{skull}"] }, 
                        A20777    = {	enable	= true,
					chat	= { 
						S	= true,
						P	= false, 
						RA	= false,
						RW	= false }, 
					dura	= 0,
					target	= true,
					name	= L["Ancestral Spirit"],
                                        ann     = L["{skull}{skull} Ressing %t {skull}{skull}"] }, 
                        -- Warlock
                        A18647    = {	enable	= true,
					chat	= { 
						S	= false,
						P	= false, 
						RA	= true,
						RW	= false }, 
					dura	= 30,
					target	= true,
					name	= L["Banish"],
                                        ann     = L["{skull}{skull} %s used! {skull}{skull}" ],
                                        fann    = L["{skull}{skull} %s is about to fade in 5 secs {skull}{skull}"],
                                        eann    = L["{skull}{skull} %s fading now! {skull}{skull}" ]},  
                        A698    = {	enable	= true,
					chat	= { 
						S	= false,
						P	= false, 
						RA	= true,
						RW	= false }, 
					dura	= 0,
					target	= false,
					name	= L["Ritual of Summoning"],
                                        ann     = L["{skull}{skull} %s used! {skull}{skull}"] }, 
                        A29893    = {	enable	= true,
					chat	= { 
						S	= false,
						P	= false, 
						RA	= true,
						RW	= false }, 
					dura	= 0,
					target	= false,
					name	= L["Ritual of Souls"],
                                        ann     = L["{skull}{skull} %s used! {skull}{skull}"] }, 
                        A27239    = {	enable	= true,
					chat	= { 
						S	= false,
						P	= false, 
						RA	= true,
						RW	= false }, 
					dura	= 0,
					target	= true,
					name	= L["Soulstone Resurrection"],
                                        ann     = L["{skull}{skull} %s used! {skull}{skull}"] }, 
                     	-- Items
                        A35476    = {	enable	= true,
					chat	= { 
						S	= false,
						P	= true, 
						RA	= false,
						RW	= false }, 
					dura	= 30,
					target	= false,
					name	= L["Drums of Battle"],
                                        ann     = L["{skull}{skull} %s used! {skull}{skull}]" , 
                                        fann    = L["{skull}{skull} %s is about to fade in 5 secs {skull}{skull}"],
                                        eann    = L["{skull}{skull} %s fading now! {skull}{skull}"] }, 
                        A35475  = {     enable  = false,
                                        chat    = {
                                                S       = false,
                                                P       = true,
                                                RA      = false,
                                                RW      = false },
                                        dura	= 30,
					target	= false,
					name	= L["Drums of War"],
                                        ann     = L["{skull}{skull} %s used! {skull}{skull}" ,] 
                                        fann    = L["{skull}{skull} %s is about to fade in 5 secs {skull}{skull}"],
                                        eann    = L["{skull}{skull} %s fading now! {skull}{skull}"] }, 
                        A35478  = {     enable  = false,
                                        chat    = {
                                                S       = false,
                                                P       = true,
                                                RA      = false,
                                                RW      = false },
                                        dura	= 30,
					target	= false,
					name	= L["Drums of Restoration"],
                                        ann     = L["{skull}{skull} %s used! {skull}{skull}" ,] 
                                        fann    = L["{skull}{skull} %s is about to fade in 5 secs {skull}{skull}"],
                                        eann    = L["{skull}{skull} %s fading now! {skull}{skull}]" },
                                        --
                        A12975  = {     enable  = true,
                                        chat    = {
                                                S       = false,
                                                P       = false,
                                                RA      = true,
                                                RW      = true },
                                        dura	= 0,
					target	= false,
					name	= L["Last Stand"],
                                        ann     = L["{skull}{skull} %s used! {skull}{skull}]" },
                        A871  = {       enable  = true,
                                        chat    = {
                                                S       = false,
                                                P       = false,
                                                RA      = true,
                                                RW      = true },
                                        dura	= 0,
					target	= false,
					name	= L["Shield Wall"],
                                        ann     = L["{skull}{skull} %s used! {skull}{skull}]" },
                        A1719  = {      enable  = false,
                                        chat    = {
                                                S       = false,
                                                P       = true,
                                                RA      = false,
                                                RW      = false },
                                        dura	= 0,
					target	= false,
					name	= L["Recklessness"],
                                        ann     = L["{skull}{skull} %s used! {skull}{skull}]" },
                        A34477  = {     enable  = true,
                                        chat    = {
                                                S       = false,
                                                P       = true,
                                                RA      = false,
                                                RW      = false },
                                        dura	= 0,
					target	= false,
					name	= L["Misdirection"],
                                        ann     = L["{skull}{skull} %s used! {skull}{skull}"] },
		},
	},
}


local RankTables = {
  { num = 2, ranksID = { 26669, 5277 } }, -- Evasion
  { num = 3, ranksID = { 11297, 2070, 6770} }, -- sap
  { num = 5, ranksID = { 38768, 1769, 1768, 1767, 1766 } }, -- kick
  { num = 6, ranksID = { 26994, 20748, 20747, 20742, 20739, 20484 } }, --rebirth
  { num = 5, ranksID = { 26983, 9863, 9862, 8918, 740 } }, -- tranquility
  { num = 3, ranksID = { 10955, 9485, 9484 } }, -- shackle undead
  { num = 6, ranksID = { 25435, 20770, 10881, 10880, 2010, 2006 } }, --ressurection
  { num = 4, ranksID = { 27154, 10310, 2800, 633 } }, -- lay on hands
  { num = 5, ranksID = { 20773, 20772, 10324, 10322, 7328 } }, -- redemption
  { num = 5, ranksID = { 20777, 20776, 20610, 20609, 2008 } }, -- ancestral spirit
  { num = 2, ranksID = { 18647, 710 } }, -- Banish
  { num = 6, ranksID = { 27239, 20765, 20764, 20763, 20762, 20707 } }, -- Soulstone
  { num = 3, ranksID = { 10278, 5599, 1022 } },
 }

function RAnnouncer:OnInitialize()
    -- Called when the addon is loaded
	AceConfig:RegisterOptionsTable("RAnnouncer", options)
	AceConfigDialog:SetDefaultSize("RAnnouncer", 680,525)
	self.db = LibStub("AceDB-3.0"):New("RAnnouncerDB", defaults, "Default")

	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	self:RegisterChatCommand("rannouncer", "ChatCommand")
	self:RegisterChatCommand("rann", "ChatCommand")
        self:Print(L["RAnnouncer v"..RAnn_version.." Loaded."])
	self:Print(L["use /rann or /rannouncer to open cofig window"])
        db = self.db.profile

end

function RAnnouncer:OnEnable()
	-- Called when the addon is enabled
end

function RAnnouncer:OnDisable()
    -- Called when the addon is disabled
end

function RAnnouncer:ChatCommand(input)
		if InCombatLockdown() then return end
		AceConfigDialog:Open("RAnnouncer") 
end

function RAnnouncer:SetValues(info, value)
        local temp = db.skillsV[info[#info-1]].enable
	db.skillsV[info[#info-1]].enable = not temp
end

function RAnnouncer:SetAValues(info, value)
	local temp = db.skillsV[info[#info-1]]["chat"][value]
	db.skillsV[info[#info-1]]["chat"][value] = not db.skillsV[info[#info-1]]["chat"][value]
end

function RAnnouncer:GetValues(info, value)
	return db.skillsV[info[#info-1]].enable
end

function RAnnouncer:GetAValues(info, value)
	return db.skillsV[info[#info-1]]["chat"][value]
end

function RAnnouncer:SendMsg(id)
	local name = db.skillsV[id].name
        local tname = UnitName("target")
        local timemax = db.skillsV[id].dura
        local strann, soonann, expann
        
        strann  = gsub(db.skillsV[id].ann, "%%s", name)
        name    = gsub(strann, "%%t", tname)
        strann  = gsub(name, "%%i", timemax)

        if timemax > 0 then
                soonann = gsub(db.skillsV[id].fann, "%%s", name)
                expann  = gsub(db.skillsV[id].eann, "%%s", name)
        end

	if db.skillsV[id]["chat"].S == true then
		SendChatMessage(strann, "SAY")
                if timemax > 0 then
                        self:ScheduleTimer(function() SendChatMessage(soonann,"SAY") end, timemax - 5)
                        self:ScheduleTimer(function() SendChatMessage(expann,"SAY") end, timemax)
                end
	end
	if db.skillsV[id]["chat"].P == true then
		SendChatMessage(strann, "PARTY")
                if timemax > 0 then
                        self:ScheduleTimer(function() SendChatMessage(soonann,"PARTY") end, timemax - 5)
                        self:ScheduleTimer(function() SendChatMessage(expann,"PARTY") end, timemax)
                end
	end
	if db.skillsV[id]["chat"].RA == true then
		SendChatMessage(strann, "RAID")
                if timemax > 0 then
                        self:ScheduleTimer(function() SendChatMessage(soonann,"RAID") end, timemax - 5)
                        self:ScheduleTimer(function() SendChatMessage(expann,"RAID") end, timemax)
                end
	end
	if db.skillsV[id]["chat"].RW == true then
		SendChatMessage(strann, "RAID_WARNING")
                if timemax > 0 then
                        self:ScheduleTimer(function() SendChatMessage(soonann,"RAID_WARNING") end, timemax - 5)
                        self:ScheduleTimer(function() SendChatMessage(expann,"RAID_WARNING") end, timemax)
                end
	end
end

-- Drums of Battle announcer

function RAnnouncer:COMBAT_LOG_EVENT_UNFILTERED(_, _, event, _, sourceName, _, _, name, _, id)
	if not UnitInRaid("player") and (GetNumPartyMembers() == 0) then return; end 
	if event == "SPELL_CAST_SUCCESS" and UnitInParty(sourceName) then
                if sourceName == player then
			idc = id
			for idx = 1, 12, 1 do
		                local tb = RankTables[idx]
				if tb then
		                        for x = 1, tb.num, 1 do
		                                if tb["ranksID"][x] == id then
		                                        idc = tb["ranksID"][1]
		                                end
				        end
		                end
		        end
			local vb = db.skillsV[string.format("A%d",idc)]
			if vb then
                                if vb.enable == true then
        				self:SendMsg(string.format("A%d",idc))
                                end
			end
                end
	end
end